Bug Hunting Session
Bug 73001 - UI: Statusbar quick functions broken if several ranges selected
Summary: UI: Statusbar quick functions broken if several ranges selected
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.2.0.0.alpha0+ Master
Hardware: Other Windows (All)
: medium normal
Assignee: Kohei Yoshida
URL:
Whiteboard: BSA target:4.3.0 target:4.2.0.2
Keywords: bibisected, possibleRegression, regression
Depends on:
Blocks: mab4.2
  Show dependency treegraph
 
Reported: 2013-12-23 23:22 UTC by Laurent BP
Modified: 2015-12-15 22:07 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Laurent BP 2013-12-23 23:22:41 UTC
Problem description: 

Steps to reproduce:
1. Select a quick function in status bar: COUNT, COUNTA, SUM, AVERAGE, MAX or MIN
2. Select several area combined with Ctrl

Current behavior:
Result is incorrect. For instance, Max or Min is the value of the last selected area, value can be higher or smaller than expected result... Can't find any logical error.

Expected behavior:
Same results as with LibO 4.1

              
Operating System: Windows 7
Version: 4.2.0.1 rc
Last worked in: 4.1.4.2 release
Comment 1 Laurent BP 2013-12-23 23:26:37 UTC
Confirmed with LibO 4.2.0.0.beta1
Comment 2 Ken Biondi 2013-12-24 01:13:34 UTC
I was able to recreate this bug in Version: 4.2.0.1
Build ID: 7bf567613a536ded11709b952950c9e8f7181a4a.  I can also confirm that this is a regression as this was not a bug in Version 4.0.6.2 (Build ID: 2e2573268451a50806fcd60ae2d9fe01dd0ce24).  I have changed status to New.

I tested using Win 8.
Comment 3 Laurent BP 2013-12-24 06:42:15 UTC
Change Keywords to regression
Comment 4 Laurent BP 2013-12-24 23:10:17 UTC
Confirmed with Version: 4.2.0.0.alpha1+
Build ID: d366c9b20ec86f3fe521812a0c22def3bfd1f05e
TinderBox: Win-x86@47-TDF, Branch:master, Time: 2013-11-14_07:51:04
Comment 5 Laurent BP 2013-12-26 21:44:02 UTC
Status bar quick functions were no operant in Version: 4.2.0.0.alpha0+
Build ID: 2f6cbe13e61c44d4bab8192a4708b698d3d9da33
TinderBox: Win-x86@6-debug, Branch:master, Time: 2013-07-25_00:00:21

Bug reproduced with Version: 4.2.0.0.alpha0+
Build ID: 4a8f7ddc290d1ea3131de6611b6833b77ac7ab1f (2013-08-28)

So, an hypothesis could be: the commit which repaired status bar quick functions between 25th July and 28th August, may have broken these functions in case of several ranges
Comment 6 Laurent BP 2014-01-03 20:58:08 UTC
Hi,

Bibisected with bibisect-2013-10-12:

b68f07a883f6e064fc9eabbf2c0b718ddfef0fbb is the first bad commit
commit b68f07a883f6e064fc9eabbf2c0b718ddfef0fbb
Author: Bjoern Michaelsen <bjoern.michaelsen@canonical.com>
Date:   Thu Oct 17 21:58:35 2013 +0000

    source-hash-a4c385f1aa98b5fb2d85136b653365fb6baa33f8
    
    commit a4c385f1aa98b5fb2d85136b653365fb6baa33f8
    Author:     Caolán McNamara <caolanm@redhat.com>
    AuthorDate: Sun Aug 4 23:12:45 2013 +0200
    Commit:     Caolán McNamara <caolanm@redhat.com>
    CommitDate: Mon Aug 5 11:21:31 2013 +0200
    
        convertion section page to .ui format
    
        Change-Id: I26990ba16ba70683960685d8c26bbfd2d66d6132

:100644 100644 daa49fa05d32abe4e7d47d385bf0424c43cdfcc7 d35616cd13b3464614c4ea7f19de0b5fd896cb16 M      autogen.log
:100644 100644 e87b81d475aafe961afbbdad972703ceaa6ba411 52fc9f22d94afc40ef61e23c357dc7e0f9d2a4fd M      ccache.log
:100644 100644 b59e00b5e0f1e2689c8be7eb13598ea488d15006 42bee39af0bdddae12cc95ffbbbe4b87095f3023 M      commitmsg
:100644 100644 c275520329af4071db01b493eceda7fe023ccd09 86e4986c08d48d57776b2d2dc8e0bf2e3741ba39 M      dev-install.log
:100644 100644 9c737d09ec216f45696a7d7ddff31d631ac1d2c5 6dfffb6da3ef540763fa3ed85ef2b4863a7db2fc M      make.log
:040000 040000 8031088acb88d630d4d29083e25b67b906b20e3d 14a0727fd795a4c854d6e7d45f0b60ab59cd54c2 M      opt

git bisect log
# bad: [25428b1e953636f74986622c5df614f04c150ed1] source-hash-cb4e009c4539c535108021934e545194b35cad9d
# good: [f0f6c65eb764f0303f59c58d320e9b0d5a894377] source-hash-4b9740b4ec3987e1d4d2ad6d20b4dcf996a4fa2e
git bisect start 'latest' 'oldest'
# good: [a72833796a7e527d9efc9ca6d8fe9b579e469105] source-hash-1472b5f87314fe660ef1a7b254e51272669f12f6
git bisect good a72833796a7e527d9efc9ca6d8fe9b579e469105
# good: [b21386bf459ae47bd6e461ea94cea6a06729a1ff] source-hash-570fe620e9d573cfc9fc260e6518563c6a6c1a3c
git bisect good b21386bf459ae47bd6e461ea94cea6a06729a1ff
# bad: [091d742e82f2b4608690c697d14f846ffc9164c7] source-hash-349c91c8ec6afc1f5c8499529d559af34d115a76
git bisect bad 091d742e82f2b4608690c697d14f846ffc9164c7
# bad: [8f9ca7d8ab2e98061706d2fae7501b75a902d93a] source-hash-3cf0b5cdb05e1d77610431b1b1328102bf05b602
git bisect bad 8f9ca7d8ab2e98061706d2fae7501b75a902d93a
# good: [465574e6f80fc8ee8b25af11b723c599a35321f2] source-hash-a38f09fec16f24886414c3e9f9574a06b56d8077
git bisect good 465574e6f80fc8ee8b25af11b723c599a35321f2
# good: [a3fcb4751e6dc8cfe81dd45192706bd7ac5345de] source-hash-ae0493ccfe7c232557fb87eef4d0444709d8b729
git bisect good a3fcb4751e6dc8cfe81dd45192706bd7ac5345de
# bad: [7f81a61901d0612283ed1f3c551eab68066d27b1] source-hash-89aeec9b1d2f771310eeb0fa4c820c19599df0f7
git bisect bad 7f81a61901d0612283ed1f3c551eab68066d27b1
# bad: [b68f07a883f6e064fc9eabbf2c0b718ddfef0fbb] source-hash-a4c385f1aa98b5fb2d85136b653365fb6baa33f8
git bisect bad b68f07a883f6e064fc9eabbf2c0b718ddfef0fbb
# first bad commit: [b68f07a883f6e064fc9eabbf2c0b718ddfef0fbb] source-hash-a4c385f1aa98b5fb2d85136b653365fb6baa33f8
Comment 7 Laurent BP 2014-01-03 22:09:36 UTC
Found Commit c2e2fbe6601ef14122371c380d91a48425a2b669
"Fix subtotal functions in the status bar."

But it made nothing wrong. Just make the error apparent.

Quick functions in status bar were broken during June 2013.
New bibisect with bibisect-2013-10-12:

c64ee04f962f148e5496ee63c1b85f5339d0cecd is the first bad commit
commit c64ee04f962f148e5496ee63c1b85f5339d0cecd
Author: Bjoern Michaelsen <bjoern.michaelsen@canonical.com>
Date:   Thu Oct 17 14:30:14 2013 +0000

    source-hash-022c54742e7997bf46a608f1ab0b500f2537f7f5
    
    commit 022c54742e7997bf46a608f1ab0b500f2537f7f5
    Author:     Tor Lillqvist <tml@iki.fi>
    AuthorDate: Tue Jun 25 07:19:41 2013 +0300
    Commit:     Tor Lillqvist <tml@iki.fi>
    CommitDate: Tue Jun 25 07:19:41 2013 +0300
    
        WaE: private field 'mrCells' is not used
    
        Change-Id: I0ab3fabb82c839f5194b0e20eb834dd86635a609

:100644 100644 4b10c5c8ddbedca0971e0839a8acc603792a447c 483b58760a06de929b32eafde25a67466c622502 M      ccache.log
:100644 100644 54c63dd94c275598f317bb54ddfdd27aaad5d8a1 fcfaf4eddaf5f8c7a66f90a052cbf2c7473cdc9b M      commitmsg
:100644 100644 e607019f9ceabe4513be6de63f5724c67ece57f9 3e023e83e964fd4b90d7bdf45eab489c7382956c M      dev-install.log
:100644 100644 2d16d57e331ca5fab2ec46ad12fe030528c544bb 47ead046b9af75e2384d8d8f51767edfa54d5dc8 M      make.log
:040000 040000 3aaab4081e7400904dc31731c74182db7e18493c 82a20807f2d069e8294cfa6e30778214a869a341 M      opt

git bisect log
# bad: [25428b1e953636f74986622c5df614f04c150ed1] source-hash-cb4e009c4539c535108021934e545194b35cad9d
# good: [f0f6c65eb764f0303f59c58d320e9b0d5a894377] source-hash-4b9740b4ec3987e1d4d2ad6d20b4dcf996a4fa2e
git bisect start 'latest' 'oldest'
# good: [a72833796a7e527d9efc9ca6d8fe9b579e469105] source-hash-1472b5f87314fe660ef1a7b254e51272669f12f6
git bisect good a72833796a7e527d9efc9ca6d8fe9b579e469105
# bad: [b21386bf459ae47bd6e461ea94cea6a06729a1ff] source-hash-570fe620e9d573cfc9fc260e6518563c6a6c1a3c
git bisect bad b21386bf459ae47bd6e461ea94cea6a06729a1ff
# good: [8febbf1f26867388acf1d005b58978cbe4130d16] source-hash-7275a051677b5646e56623b3addc783880ce8e9b
git bisect good 8febbf1f26867388acf1d005b58978cbe4130d16
# bad: [3897b261df824b9e25e5226d4fc17f28bfca2274] source-hash-61db96daa87754af24355d7ac94ee0305f22ff87
git bisect bad 3897b261df824b9e25e5226d4fc17f28bfca2274
# good: [cd4dab4f7cd1e732b0a3ca1eaadb9d52e6863867] source-hash-b139f6fedfcf3cbed0eadeb007e2155b576413d2
git bisect good cd4dab4f7cd1e732b0a3ca1eaadb9d52e6863867
# bad: [c133035ff38a0a861975e299b0debff65eff64d1] source-hash-344d80ee1d3829b28c18135ac4f0500d4b69aedd
git bisect bad c133035ff38a0a861975e299b0debff65eff64d1
# bad: [633649b99650518c34fa17096a08fdce1955e0a6] source-hash-4d5fc661d37d03129b8054e494c03bed1933231d
git bisect bad 633649b99650518c34fa17096a08fdce1955e0a6
# bad: [c64ee04f962f148e5496ee63c1b85f5339d0cecd] source-hash-022c54742e7997bf46a608f1ab0b500f2537f7f5
git bisect bad c64ee04f962f148e5496ee63c1b85f5339d0cecd
# first bad commit: [c64ee04f962f148e5496ee63c1b85f5339d0cecd] source-hash-022c54742e7997bf46a608f1ab0b500f2537f7f5
Comment 8 Laurent BP 2014-01-03 22:24:54 UTC
Suspected commit: c008dc483f8c6840803983e7e351cec6fdd32070
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 24 11:52:18 2013 -0400

    Switch to using multi_type_vector for cell storage.
    
    The old style cell storage is no more.  Currently the code is buildable,
    but crashes during unit test.
    
    Change-Id: Ie688e22e95c7fb02b9e97b23df0fc1883a97945f
Comment 9 Laurent BP 2014-01-03 22:41:35 UTC
CC to Kohei:
The bug may have been introduced with multi_type_vector
Comment 10 Kohei Yoshida 2014-01-06 19:16:00 UTC
I'll take it.
Comment 11 Commit Notification 2014-01-06 21:14:25 UTC
Kohei Yoshida committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4a7a6b46c0dc779581f271b9e6c13c365eca7ab8

fdo#73001: Simplify the selection function logic & calculate correct results.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 Commit Notification 2014-01-06 21:25:58 UTC
Kohei Yoshida committed a patch related to this issue.
It has been pushed to "libreoffice-4-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=c009bdb061d074bbddd58a16bdf65022e2099ba5&h=libreoffice-4-2

fdo#73001: Simplify the selection function logic & calculate correct results.


It will be available in LibreOffice 4.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 13 Kohei Yoshida 2014-01-06 21:26:53 UTC
Fixed.
Comment 14 Laurent BP 2014-01-07 16:30:22 UTC
Verified with Version: 4.3.0.0.alpha0+
Build ID: 49bc2ac28fed51425f257558db4ed1e9c3522e6f

Works fine. Thanks Kohei :)
Comment 15 Robinson Tryon (qubit) 2015-12-15 22:07:22 UTC
Migrating Whiteboard tags to Keywords: (PossibleRegression bibisected )
[NinjaEdit]